#include "\vbs2\headers\function_library.hpp"
#include "defs.hpp"

KRON_rotpoint = {
	private["_cp","_cx","_cy","_a","_cd","_sd","_tx","_ty","_xout","_yout","_out"];
	_cp=_this select 0; 
	_cx=_cp select 0; 
	_cy=_cp select 1; 
	_a=_this select 1; 
	_cd=cos(_a*-1); 
	_sd=sin(_a*-1); 
	_tx=_this select 2; 
	_ty=_this select 3; 
	_xout=if (_a!=0) then {
		_cx+ (_cd*_tx - _sd*_ty)
	} else {
		_cx+_tx;
	}; 
	_yout=if (_a!=0) then {
		_cy + (_sd*_tx + _cd*_ty);
	} else {
		_cy+_ty;
	}; 
	_out = [_xout,_yout,0];
	_out
};

_relPos = {
	private ["_pos","_dist","_dir","_sin","_cos"];
	_pos  = _this select 0;
	_dist = _this select 1;
	_dir  = _this select 2;
	_sin = sin _dir;
	_cos = cos _dir;
	_pos = [(_pos select 0) + _dist*_sin, (_pos select 1) + _dist*_cos];
	_pos
};

KRON_addangle = {
	private["_a","_d"]; 
	_a=_this select 0; 
	_d=_this select 1; 
	_a=_a+_d; 
	if (_a<0) then {
		_a=_a+360;
	}; 
	_a=_a mod 360; 
	_a
};

_cutDecimals = {
	private ["_in","_digits","_fact"];
	_in = _this select 0;
	_digits = _this select 1;
	_fact = 10 ^ _digits;
	(round ((_this select 0) * _fact)) / _fact
};

KRON_xOff = {
	private["_i","_s","_dx"];
	_i=(_this select 0); 
	_s=_this select 1;	
	_dx=(_i*_s)-(_s*((count KRON_targetType)-1)/2); 
	_dx
};

KRON_makemarker = {
	private["_p","_x","_y","_mrk"];
	_p=_this select 0; 
	_x=_p select 0; 
	_y=_p select 1; 
	_mrk=format["mrk_%1_%2_%3",random 1000000,_x,_y]; 
	_nul=createMarker[_mrk,[_x,_y]];	
	_mrk setMarkerType "DOT"; 
	_mrk setMarkerSize [.5,.5];	
};

KRON_weapondir = {
	private["_g","_v","_a"];
	if (count _this==0) then {
		{
			_a=((vehicle player) weaponDirection _x) select 2; 
			if (_a!=0) then {
				_g=_x;
			}
		}forEach weapons (vehicle player);
	} else {
		_g = _this select 0;
	}; 
	_a=floor(90*(((vehicle player) weaponDirection _g) select 2)*100)/100;
	_a
};

// create a regular object (walls)
KRON_makeObj = {
	private["_type","_pos","_dir","_obj"];
	_type=_this select 0; 
	_pos=_this select 1; 
	_dir=_this select 2; 
	_obj = _type createVehicle _pos; 
	_obj setDir _dir; 
	_obj setPos _pos; 
	_obj setVectorUp [0,0,1]; 
	_obj
};

// create a target object	
KRON_maketarget = {
	private["_idx","_pos","_unit","_trgname"];
	_idx=_this select 0;
	_pos=[KRON_orgPos, KRON_orgDir, [_idx,GAP_WIDTH] call KRON_xOff, KRON_dist] call KRON_rotpoint;
	_unit=0;
	KRON_Cnt=KRON_Cnt+1;
	if (((KRON_targetType select _idx) select 0) isKindOf "Man") then {
		call compile format["""%1"" createUnit [_pos, KRON_grp,""KRON_U_%2 = this"", 0.1, ""private""]",(KRON_targetType select _idx) select 0,KRON_Cnt];
		call compile format["_unit=KRON_U_%1",KRON_Cnt];
		_unit setPos [_pos select 0, _pos select 1, .5];
		{_unit removeMagazine _x} forEach magazines _unit;
		_unit setBehaviour "CARELESS"; 
		_unit allowFleeing 0; 
		_unit disableAI "TARGET";
		_unit disableai "PATHPLAN";
		_unit setCombatMode "BLUE";
		_unit doWatch objNull;
		_unit setUnitPos (KRON_unitpos select _idx);
		if (KRON_run!="") then {
			// create waypoints for AI
			_wp = KRON_grp addWaypoint [[1111,1111],0];
			_wp setWaypointType "MOVE";
			_wp setWaypointSpeed KRON_run;
			_wp = KRON_grp addWaypoint [[2222,2222],0];
			_wp setWaypointType "MOVE";
			_wp = KRON_grp addWaypoint [[1111,1111],0];
			_wp setWaypointType "CYCLE";
			[_unit] call _setWP;
		} else {
			_unit disableAI "MOVE";
		};
		_unit stop !KRON_Move;
	} else {
		if (isClass(configFile >> "cfgVehicles" >> (KRON_targetType select _idx) select 0)) then {
			_unit = [(KRON_targetType select _idx) select 0,_pos,(KRON_targetType select _idx) select 1] call KRON_makeobj;
			_unit setVehicleVarName format["KRON_U_%1",KRON_Cnt]; 
			_unit call compile format["KRON_U_%1=_unit",KRON_Cnt];
		};
	};
	if (typename _unit=="OBJECT") then {
		_unit setDir ([KRON_orgDir,(KRON_targetType select _idx) select 1] call KRON_addangle);
		KRON_targets set [_idx,_unit];
		_unit addEventHandler["hit","KRON_HQ globalchat format['""%1"" hit, damage:%2',getText(configFile >> 'cfgVehicles' >> typeof (_this select 0) >> 'displayName'),floor((_this select 2)*100)/100]; "]; 
		call compile format["_unit addEventHandler[""killed"",""setAccTime .99; KRON_HQ globalchat '""""%2"""" killed'; deleteVehicle (_this select 0)""]",_idx,getText(configFile >> "cfgVehicles" >> typeof _unit >> "displayName")];
		_trgname=format["KRON_Trig_%1",KRON_Cnt];
		call compile format["%1=createTrigger[""EmptyDetector"",[0,0]]",_trgname];
		call compile format["%1 setTriggerArea[0,0,0,true]",_trgname];
		call compile format["%1 setTriggerActivation[""NONE"",""PRESENT"",false]",_trgname];
		call compile format["%1 setTriggerTimeout[3,3,3,false]",_trgname];
		call compile format["%1 setTriggerStatements[""!(alive KRON_U_%3)"", ""[%2] call KRON_maketarget; setAccTime KRON_SlowMo; deleteVehicle KRON_Trig_%3"", """"]",_trgname,_idx,KRON_Cnt];
	};
	_unit;
};	

_makeWalls = {
	private ["_off","_foff","_z","_r","_pos","_woff","_obj","_f","_f1","_f2"];
	// (re)create distance markers
	if !(isNil 'KRON_walls') then {
		{deleteVehicle _x}forEach KRON_walls;
	};
	_off=([count KRON_targetType,GAP_WIDTH] call KRON_xOff)+KRON_MoveDist;
	KRON_walls=[];
	for [{_d=50},{_d<=KRON_dist},{_d=_d+50}] do {
		_z = if ((_d mod 100)==0) then {0} else {-.5}; // have 100m markers stick out higher 
		_pos=[KRON_orgPos, KRON_orgDir, 0, 44] call KRON_rotpoint;
		mark setPos _pos;
		{
			for "_r" from 1 to 2 do {
				_woff=_x*(_off+(WALLSIZE select 0)*_r);
				if (_x==1) then {_woff=_woff+WALLORIGIN}; // origin is on the left edge of the border
				_pos=[KRON_orgPos, KRON_orgDir, _woff, _d-(WALLSIZE select 1)] call KRON_rotpoint;
				_pos set [2,_z];
				_obj = [WALLMODEL,_pos,KRON_orgDir] call KRON_makeObj;
				_obj allowDammage false;
				KRON_walls=KRON_walls+[_obj];
			};
		}forEach [-1,1];
		// make flags at full 100m marks
		if (_z==0) then {
			for "_f" from 1 to round(_d/100) do {
				_foff = _off+_f*WALLPART+(FLAGOFF select 0);
				_pos=[KRON_orgPos, KRON_orgDir, -_foff, _d-(FLAGOFF select 1)] call KRON_rotpoint;
				_obj=[FLAGMODEL,_pos,0] call KRON_makeobj;
				KRON_walls=KRON_walls+[_obj];
				// make 2 flags at the outside range if AI is running
				if (KRON_run!="") then {
					_pos=[KRON_orgPos, KRON_orgDir, _foff, _d-(FLAGOFF select 1)] call KRON_rotpoint;
					_obj=[FLAGMODEL,_pos,0] call KRON_makeobj;
					KRON_walls=KRON_walls+[_obj];
				};
			};
		};
	};
};

// reposition target AI's waypoints
_setWP = {
	private["_unit","_pos","_pos1","_pos2"];
	_unit=_this select 0;
	_pos = ([getPos player,KRON_dist,KRON_orgDir] call _relPos);
	_pos1 = [_pos,KRON_MoveDist+3,KRON_orgDir+90] call _relPos;
	[KRON_grp,1] setWaypointPosition [_pos1, 0];
	_pos2 = [_pos,KRON_MoveDist+3,KRON_orgDir-90] call _relPos;
	[KRON_grp,2] setWaypointPosition [_pos2, 0];
	[KRON_grp,3] setWaypointPosition [_pos1, 0];
};
